n=sba_motstr_levmar(numpts3D, 0, nframes, nconstframes, vmask, motstruct, cnp, pnp, imgpts, covimgpts, mnp,
			img_projRTS, NULL, (void *)(&globs), MAXITER2, verbose, opts, info);

//Xida's comments: this one is for single refraction
static void img_projRTS(int j, int i, double *aj, double *bi, double *xij, void *adata)
{
	double *Kparms, *pr0;
	struct globs_ *gl;
	//Xida's comments: variables for refractive projection
	double PMat[12], Center[3], RMat[9], RMatInv[9], dist; 
	double refNormal[3], ptI[3], tMat[3], ptRT[3];
	double projX, projY;
	double tranPt[3], newPt[4], imProj[3];

	gl=(struct globs_ *)adata;
	Kparms=gl->intrcalib;
	//pr0=gl->rot0params+j*FULLQUATSZ; // full quat for initial rotation estimate
	pr0 = gl->rot0params+j; //modified by Xida
	
	//Xida's comments: use refractive back projection, comment the following line
	//calcImgProj(Kparms, pr0, aj, aj+3, bi, xij); // 3 is the quaternion's vector part length
	
	//Xida's comments: start refractive projection
	//set the left camera parameters
	PMat[0] = 1.706994840242754e+03; PMat[1] = 0; PMat[2] = 7.028802283352511e+02;
	PMat[3] = 5.221395981919011e+02; PMat[4] = 1.506171917861255e+02; PMat[5] = 1536;
	PMat[6] = 7.530859589306267e+02; PMat[7] = 3.916046986439259e+02; PMat[8] = 0.196116135138184;
	PMat[9] = 0; PMat[10] = 0.980580675690920; PMat[11] = 0.509901951359279;
	Center[0] = -0.1; Center[1] = 0; Center[2] = -0.5;
	RMat[0] = 0.894427190999916; RMat[1] = 0; RMat[2] = -0.447213595499958;
	RMat[3] = 0; RMat[4] = 1; RMat[5] = 0;
	RMat[6] = 0.447213595499958; RMat[7] = 0; RMat[8] = 0.894427190999916;
	RMatInv[0] = 0.894427190999916; RMatInv[1] = 0; RMatInv[2] = 0.447213595499958;
	RMatInv[3] = 0; RMatInv[4] = 1; RMatInv[5] = 0;
	RMatInv[6] = -0.447213595499958; RMatInv[7] = 0; RMatInv[8] = 0.894427190999916;
	dist = aj[0]; //dist = pr0[0];
	refNormal[0] = -0.447213595499958; refNormal[1] = 0; refNormal[2] = -0.894427190999916;

	//set the right camera parameters, only change the different ones
	if(j != 0) {
		Center[0] = 0.1;
		PMat[0] = 1.305348995479753e+03; PMat[2] = 1.305348995479753e+03;
		PMat[4] = -1.506171917861255e+02; PMat[8] = -0.196116135138184;
		RMat[0] = 0.928476690885259; RMat[2] = 0.371390676354104;
		RMat[6] = -0.371390676354104; RMat[8] = 0.928476690885259;
		RMatInv[0] = 0.928476690885259; RMatInv[2] = -0.371390676354104;
		RMatInv[6] = 0.371390676354104; RMatInv[8] = 0.928476690885259;
		refNormal[0] = 0.371390676354104; refNormal[2] = -0.928476690885259;
	}

	for(i = 0; i < 3; i++)
		ptI[i] = Center[i]-dist*refNormal[i];
	tMat[0] = RMat[0]*ptI[0] + RMat[1]*ptI[1] + RMat[2]*ptI[2];
	tMat[1] = RMat[3]*ptI[0] + RMat[4]*ptI[1] + RMat[5]*ptI[2];
	tMat[2] = RMat[6]*ptI[0] + RMat[7]*ptI[1] + RMat[8]*ptI[2];

	ptRT[0] = RMat[0]*bi[0] + RMat[1]*bi[1] + RMat[2]*bi[2] - tMat[0];
	ptRT[1] = RMat[3]*bi[0] + RMat[4]*bi[1] + RMat[5]*bi[2] - tMat[1];
	ptRT[2] = RMat[6]*bi[0] + RMat[7]*bi[1] + RMat[8]*bi[2] - tMat[2];

	ref3DImg(ptRT[0], ptRT[1], ptRT[2], dist, 1.33, &projX, &projY);

	tranPt[0] = projX+tMat[0]; tranPt[1] = projY+tMat[1]; tranPt[2] = tMat[2];
	newPt[0] = RMatInv[0]*tranPt[0] + RMatInv[1]*tranPt[1] + RMatInv[2]*tranPt[2];
	newPt[1] = RMatInv[3]*tranPt[0] + RMatInv[4]*tranPt[1] + RMatInv[5]*tranPt[2];
	newPt[2] = RMatInv[6]*tranPt[0] + RMatInv[7]*tranPt[1] + RMatInv[8]*tranPt[2];
	newPt[3] = 1;

	imProj[0] = PMat[0]*newPt[0] + PMat[1]*newPt[1] + PMat[2]*newPt[2] + PMat[3]*newPt[3];
	imProj[1] = PMat[4]*newPt[0] + PMat[5]*newPt[1] + PMat[6]*newPt[2] + PMat[7]*newPt[3];
	imProj[2] = PMat[8]*newPt[0] + PMat[9]*newPt[1] + PMat[10]*newPt[2] + PMat[11]*newPt[3];

	xij[0] = imProj[0]/imProj[2]; xij[1] = imProj[1]/imProj[2];
}

//Xida's comments: this one is for multiple refractions
//when using this one, comment the above one
// j = camera index
// i = 3D point index
// aj = camera parameter array
// bi = 3D point coordinate array
// xij = observed coordinate of point i camera j
// adata = nothing
static void img_projRTS(int j, int i, double *aj, double *bi, double *xij, void *adata)
{
	double *Kparms, *pr0;
	struct globs_ *gl;
	//Xida's comments: variables for refractive projection
	double PMat[12], Center[3], dist1, dist2; 
	double refNormal[3], tranPt[3], newPt[4], imProj[3];
	double rx = 0, ry = 0, rz = 0;

	gl=(struct globs_ *)adata;
	Kparms=gl->intrcalib;
	//pr0=gl->rot0params+j*FULLQUATSZ; // full quat for initial rotation estimate
	pr0 = gl->rot0params+j*2; //modified by Xida
	
	//Xida's comments: use refractive back projection, comment the following line
	//calcImgProj(Kparms, pr0, aj, aj+3, bi, xij); // 3 is the quaternion's vector part length
	
	//Xida's comments: start refractive projection
	//set the left camera parameters
	dist1 = aj[0]; dist2 = aj[1];
	PMat[0] = 1.706994840242754e+03; PMat[1] = 0; PMat[2] = 7.028802283352511e+02;
	PMat[3] = 5.221395981919011e+02; PMat[4] = 1.506171917861255e+02; PMat[5] = 1536;
	PMat[6] = 7.530859589306267e+02; PMat[7] = 3.916046986439259e+02; PMat[8] = 0.196116135138184;
	PMat[9] = 0; PMat[10] = 0.980580675690920; PMat[11] = 0.509901951359279;
	Center[0] = -0.1; Center[1] = 0; Center[2] = -0.5;
	refNormal[0] = -0.447213595499958; refNormal[1] = 0; refNormal[2] = -0.894427190999916;
	
	//set the right camera parameters, only change the different ones
	if(j != 0) {
		Center[0] = 0.1;
		PMat[0] = 1.305348995479753e+03; PMat[2] = 1.305348995479753e+03;
		PMat[4] = -1.506171917861255e+02; PMat[8] = -0.196116135138184;
		refNormal[0] = 0.371390676354104; refNormal[2] = -0.928476690885259;
	}

	tranPt[0] = bi[0]-Center[0]; tranPt[1] = bi[1]-Center[1]; tranPt[2] = bi[2]-Center[2];
	SolveForwardProjectionCase3(tranPt, dist1, dist1+dist2, refNormal, &rx, &ry, &rz);
	newPt[0] = rx+Center[0]; newPt[1] = ry+Center[1]; newPt[2] = rz+Center[2]; newPt[3] = 1;

	imProj[0] = PMat[0]*newPt[0] + PMat[1]*newPt[1] + PMat[2]*newPt[2] + PMat[3]*newPt[3];
	imProj[1] = PMat[4]*newPt[0] + PMat[5]*newPt[1] + PMat[6]*newPt[2] + PMat[7]*newPt[3];
	imProj[2] = PMat[8]*newPt[0] + PMat[9]*newPt[1] + PMat[10]*newPt[2] + PMat[11]*newPt[3];

	xij[0] = imProj[0]/imProj[2]; xij[1] = imProj[1]/imProj[2];
}

void RefractedRay(double vi1, double vi2, double n1, double n2, double mu1, double mu2, double *re)
{
	double a = mu1/mu2;
	double b;
	double len = sqrt(n1*n1+n2*n2);
	n1 /= len; n2/= len;
	b = -mu1*(vi1*n1+vi2*n2)-sqrt(mu1*mu1*pow(vi1*n1+vi2*n2, 2)-
		(mu1*mu1-mu2*mu2)*(vi1*vi1+vi2*vi2));
	b = b/mu2;
	re[0] = a*vi1+b*n1;
	re[1] = a*vi2+b*n2;
}

void SolveForwardProjectionCase3(double *pt, double d, double d2, double *nor, double *rx, double *ry, double *rz)
{
	const double epsilon = 0.000000001;
	double mu1 = 1.5, mu2 = 1.33, u, v, x, e, len;
	double z1[3];
	double z2[3] = {0, 0, 0};
	double POR[3] = {0, 0, 0};
	gsl_poly_complex_workspace *w = gsl_poly_complex_workspace_alloc (13);
	double a[13], z[24];
	int valid[12] = {-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1};
	int i, validNum = 0;
	double v2[2], v3[2], q2[2], vrd[2];
	//some variables for optimize the a[13] array
	double mu1S, mu2S, mu1Sm1, mu2Sm1, uS, dS, dmd2S, d2mvS;
	double tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6, tmp7, tmp8;

	*rx = 0; *ry = 0; *rz = 1; //initialization
	//cross(nor, pt)
	POR[0] = nor[1]*pt[2]-nor[2]*pt[1];
	POR[1] = nor[2]*pt[0]-nor[0]*pt[2];
	POR[2] = nor[0]*pt[1]-nor[1]*pt[0];
	//norm(POR)
	len = sqrt(POR[0]*POR[0]+POR[1]*POR[1]+POR[2]*POR[2]);
	for(i = 0; i < 3; i++)
		POR[i] /= len;
	
	//z1 = -n;
	z1[0] = -nor[0]; z1[1] = -nor[1]; z1[2] = -nor[2];
	//norm(z1)
	len = sqrt(z1[0]*z1[0]+z1[1]*z1[1]+z1[2]*z1[2]);
	for(i = 0; i < 3; i++)
		z1[i] /= len;

	//cross(POR, z1)
	z2[0] = POR[1]*z1[2]-POR[2]*z1[1];
	z2[1] = POR[2]*z1[0]-POR[0]*z1[2];
	z2[2] = POR[0]*z1[1]-POR[1]*z1[0];
	//norm(z2)
	len = sqrt(z2[0]*z2[0]+z2[1]*z2[1]+z2[2]*z2[2]);
	for(i = 0; i < 3; i++)
		z2[i] /= len;
	
	//v = p'*z1
	//u = p'*z2
	v = pt[0]*z1[0]+pt[1]*z1[1]+pt[2]*z1[2];
	u = pt[0]*z2[0]+pt[1]*z2[1]+pt[2]*z2[2];
	
	mu1S = mu1*mu1; mu2S = mu2*mu2; mu1Sm1 = mu1S-1; mu2Sm1 = mu2S-1;
	uS = u*u; dS = d*d; dmd2S = pow(d-d2, 2); d2mvS = pow(d2-v, 2);
	tmp0 = uS*mu1Sm1+dS*mu1S; tmp1 = mu2Sm1*dmd2S;
	tmp2 = mu1Sm1*d2mvS; tmp3 = dS*mu2S*mu1Sm1;
	tmp4 = 2*dS*mu1S*u*mu2Sm1+2*dS*mu2S*u*mu1Sm1;
	tmp5 = mu2Sm1*tmp0-tmp1-tmp2+tmp3;
	tmp6 = dS*mu2S*tmp0-dS*mu2S*dmd2S-dS*mu1S*d2mvS+dS*mu1S*uS*mu2Sm1;
	tmp7 = mu1Sm1*mu2Sm1; tmp8 = mu1S*mu2S;

	a[12] = pow(mu1Sm1, 2)*pow(mu2Sm1, 2);
	a[11] = (-4)*u*a[12];
	a[10] = 4*uS*a[12]+2*tmp7*tmp5;
	a[9] = - 2*tmp7*tmp4-4*u*tmp7*tmp5;
	a[8] = pow(tmp5, 2)+2*tmp7*tmp6-4*mu1Sm1*tmp1*d2mvS+4*u*tmp7*tmp4;
	a[7] = -2*tmp4*tmp5-4*u*tmp7*tmp6-4*pow(d, 4)*tmp8*u*tmp7;
	a[6] = 2*tmp5*tmp6+pow(tmp4, 2)-4*dmd2S*(dS*mu1S*mu2Sm1+tmp3)*d2mvS+10*pow(d, 4)*tmp8*uS*tmp7;
	a[5] = -2*tmp4*tmp6-4*pow(d, 4)*tmp8*u*tmp5-4*pow(d, 4)*tmp8*pow(u, 3)*tmp7;
	a[4] = pow(tmp6, 2)+2*pow(d, 4)*tmp8*uS*tmp5-4*pow(d, 4)*tmp8*dmd2S*d2mvS+4*pow(d, 4)*tmp8*u*tmp4;
	a[3] = -2*pow(d, 4)*tmp8*uS*tmp4-4*pow(d, 4)*tmp8*u*tmp6;
	a[2] = 4*pow(d, 8)*pow(mu1, 4)*pow(mu2, 4)*uS+2*pow(d, 4)*tmp8*uS*tmp6;
	a[1] = (-4)*pow(d, 8)*pow(mu1, 4)*pow(mu2, 4)*pow(u, 3);
	a[0] = pow(d, 8)*pow(mu1, 4)*pow(mu2, 4)*pow(u, 4);

	gsl_poly_complex_solve (a, 13, w, z);
	gsl_poly_complex_workspace_free (w);

	for (i = 0; i < 12; i++) {
		if(fabs(z[2*i+1]) < epsilon) {
			valid[validNum] = i;
			validNum++;
		}
	}

	if(validNum == 0) {
		printf("Warning: no refrax solution found. Returning bogus answer.\n");
		return;
	}

	for(i = 0; i < validNum; i++) {
		x = z[valid[i]*2];
		RefractedRay(x, d, 0, -1, 1, mu1, v2);
		q2[0] = x + (d-d2)*v2[0]/(-v2[1]);
		q2[1] = d + (d-d2)*v2[1]/(-v2[1]);
		RefractedRay(v2[0], v2[1], 0, -1, mu1, mu2, v3);
		vrd[0] = u-q2[0]; vrd[1] = v-q2[1];
		e = fabs(vrd[0]*v3[1]-vrd[1]*v3[0]);

		if(e < epsilon) {
			*rx = x*z2[0] + d*z1[0];
			*ry = x*z2[1] + d*z1[1];
			*rz = x*z2[2] + d*z1[2];
			return;
		}
	}
}

double refrac2DImg(double sx, double sy, double e, double r)
{
	const double epsilon = 0.000000001;
	double N = 1/(r*r)-1;
	int sign = 1; 
	double a[5], z[8];
	int valid[4] = {-1, -1, -1, -1};
	int validNum = 0;
	int i;
	gsl_poly_complex_workspace *w = gsl_poly_complex_workspace_alloc (5);

	if(fabs(sy) < epsilon)
		return 0;
	if(fabs(sx) < epsilon)
		return sy;
	if(sy < 0)	sign = 0;
	sy = fabs(sy);

	a[4] = N; a[3] = -2*N*sy; a[2] = N*sy*sy+(sx*sx)/(r*r)-e*e;
	a[1] = 2*e*e*sy; a[0] = -e*e*sy*sy;

	gsl_poly_complex_solve (a, 5, w, z);
	gsl_poly_complex_workspace_free (w);

	for (i = 0; i < 4; i++) {
		if(fabs(z[2*i+1]) < epsilon && z[2*i] >= epsilon &&
			z[2*i] <= sy) {
			valid[validNum] = i;
			validNum++;
		}
	}
	if(validNum == 0) {
		printf("Warning: no refrax solution found. Returning bogus answer.\n");
		return 0;
	}
	if(validNum > 1) {
		printf("Warning: multiple refrax solutions found. Returning the first one.\n");
		if(sign == 0)
			return -z[2*valid[0]];
		else
			return z[2*valid[0]];
	}
	if(sign == 0)
		return -z[2*valid[0]];
	else
		return z[2*valid[0]];
}

void ref3DImg(double sx, double sy, double sz, double e, double r, double *x, double *y)
{
	const double epsilon = 0.000000001;
	double h = sqrt(sx*sx+sy*sy);

	if(h < epsilon) {
		*x = 0; *y = 0;
	}
	else {
		double w = refrac2DImg(sz, h, e, r);
        *x = sx*w/h;
        *y = sy*w/h;
	}
}
