%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Thesis title: Underwater Camera Calibration and 3D Reconstruction
% http://hdl.handle.net/10402/era.38695
% Author: Timothy Yau
%
% This file is adapted and modified from code accompanying the paper:
%   A. Agrawal, S. Ramalingam, Y. Taguchi, and V. Chari. A theory of 
%   multilayer flat refractive geometry. CVPR 2012.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% solve the forward projection for flat refraction and compute the point on
% the water surface where refraction happens

function [M] = SolveFlatRefractionPointTwoLayerCase3(tau1,tau2,n,mu1,mu2,p)

d0 = tau1;
d1 = tau2;

M = zeros(3,1);

%refraction plane
RefPlane = cross(n,p);
RefPlane = RefPlane/norm(RefPlane);

% take first axis to be normal direction, away from the camera
z1 = -n;
z1 = z1/norm(z1);

z2 = cross(RefPlane,z1);
z2 = z2/norm(z2);

v = p'*z1;
u = p'*z2;


y = refrac2DImg2(v - d0, u, d0, mu1, mu2, d1);
M = d0*z1 + y*z2;





















