%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Thesis title: Underwater Camera Calibration and 3D Reconstruction
% http://hdl.handle.net/10402/era.38695
% Author: Timothy Yau
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

calibRed = 'result/Calib_Results_red.mat';
calibBlue = 'result/Calib_Results_blue.mat';
gridPtsData = 'AlignedGridPointData.mat';

saveFile = 'ColorAlignment.mat';

load(gridPtsData, 'AssignedGridR', 'AssignedPointsR', 'AssignedGridB', 'AssignedPointsB');

if size(AssignedPointsR,1) > 1
    error(['File ' gridPtsData ' contains data for more than one camera. LCA alignment is for one camera at a time.']);
end

%%%%%% Aligning blue channel to red channel %%%%%%

Xrall = zeros(0,2);
Xball = zeros(0,2);
for i = 1:numel(AssignedGridR)
    [C, ia, ib] = intersect(AssignedGridR{i}, AssignedGridB{i}, 'rows');
    
    Xrall = [Xrall; AssignedPointsR{i}(ia,:)];
    Xball = [Xball; AssignedPointsB{i}(ib,:)];
end

[Xrm, Xbm, blueScale, blueKcWarp, blueShift] = adjustRadialDistortion2(Xrall, Xball, calibRed, calibBlue);

clear AssignedGridR AssignedGridB AssignedPointsR AssignedPointsB Xrall Xball Xrm Xbm

save(saveFile, 'blueScale', 'blueKcWarp', 'blueShift');
