%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Thesis title: Underwater Camera Calibration and 3D Reconstruction
% http://hdl.handle.net/10402/era.38695
% Author: Timothy Yau
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [camIDs, seqNums] = getCameraIDs(allImages, sep)
% allImages is a struct array obtained using the dir() function
% Find all the camera ids and sequence numbers

    camIDs = cell(0,1);
    seqNums = cell(0,1);

    for i=1:numel(allImages)
        imgName = allImages(i).name;

        [seqNum, remain] = strtok(imgName, sep);
        camID = strtok(remain((length(sep)+1):end), '.');

        camIDs{end+1} = camID;
        seqNums{end+1} = seqNum;
    end

    camIDs = unique(camIDs);
    seqNums = unique(seqNums);
