%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Thesis title: Underwater Camera Calibration and 3D Reconstruction
% http://hdl.handle.net/10402/era.38695
% Author: Timothy Yau
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [R] = w2R(w)
% Convert from axis-angle representation of rotation to a rotation matrix.
% Based on:
% http://en.wikipedia.org/wiki/Rotation_matrix#Conversion_from_and_to_axis-angle

    theta = norm(w);
    w = w / theta;
    wHat = CrossMatrix(w);
    
    R = eye(3) + wHat * sin(theta) + wHat^2 * (1 - cos(theta));
