%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Thesis title: Underwater Camera Calibration and 3D Reconstruction
% http://hdl.handle.net/10402/era.38695
% Author: Timothy Yau
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [X] = undistortAndScale(X, scaleFactor, shift, fc, cc, kc, alpha_c)
% scaleFactor is 2-vector giving the x and y scales
% shift is 2-vector giving x and y shift amounts
% X is N-by-2 matrix of points
    n = size(X,1);

    X = undistort_points(X,fc,cc,kc,alpha_c);
    
    ccScaled = scaleFactor .* cc;
    X = X .* (ones(n,1)*scaleFactor') - ones(n,1)*(ccScaled' - cc' - shift');
    