%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Thesis title: Underwater Camera Calibration and 3D Reconstruction
% http://hdl.handle.net/10402/era.38695
% Author: Timothy Yau
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [Xout] = undistort_points(X, fc, cc, kc, alpha_c)
    if ~exist('fc')|~exist('cc')|~exist('kc')|~exist('alpha_c'),
        fprintf(1,'No intrinsic camera parameters available.\n');
        return;
    end;
    
    KK = [fc(1) alpha_c*fc(1) cc(1);0 fc(2) cc(2) ; 0 0 1];

    Xout = normalize(X',fc,cc,kc,alpha_c)';
    Xout = (KK * [Xout'; ones(1,size(X,1))])';
    Xout = Xout(:,1:2);